package com.liang.service;

import com.liang.common.base.BaseResult;
import com.liang.entity.SysUserRole;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.Map;
import java.util.Set;

/**
 * (SysUserRole)表服务接口
 *
 * @author makejava
 * @since 2023-02-19 21:37:39
 */
public interface SysUserRoleService {

    /**
     * 通过ID查询单条数据
     *
     * @param userId 主键
     * @return 实例对象
     */
    SysUserRole queryById(Integer userId);

    /**
     * 分页查询
     *
     * @param sysUserRole 筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<SysUserRole> queryByPage(SysUserRole sysUserRole, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param sysUserRole 实例对象
     * @return 实例对象
     */
    SysUserRole insert(SysUserRole sysUserRole);

    /**
     * 修改数据
     *
     * @param sysUserRole 实例对象
     * @return 实例对象
     */
    SysUserRole update(SysUserRole sysUserRole);

    /**
     * 通过主键删除数据
     *
     * @param userId 主键
     * @return 是否成功
     */
    boolean deleteById(Integer userId);

    Set<String> listUserRoleByUserId(Integer userId);

    /**
     * 用户授权
     *
     * @param userId
     * @param roles
     * @return
     */
    BaseResult doAuthorize(Integer userId, String roles);

    /**
     * 根据用户id查询用户所含角色，给xmselect赋值
     */
    Map<String, Object> listRoleByUserId(Integer userId);
}
